#!/usr/bin/perl

###################################################
#### 	  developed by: Nason Tackett          ####
####             nason@nason.com               ####
###################################################

print "Content-type:text/html\n\n";

@DAYS = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");

use DBI();
require "db.cfg";       ## Database Connection

$DBI::result = $dbh->prepare("select * from `gig types`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $EVENT[$row[0]]=$row[1];
        $COLORS[$row[0]]=$row[2];
}

print "<center><table border=1><caption>Event Type Color Codes:</caption><tr>\n";
$num=0;
foreach $gig_type (@EVENT) {
        if ($num > 0) {
                print "<td><font color=\"#$COLORS[$num]\">$EVENT[$num]</td>\n";
        }
        $num++;
}
print "</tr></table></center><br>\n";

$DBI::result = $dbh->prepare("select * from `gigs` WHERE (`active`='1' AND `pending`='0') ORDER BY `date` ASC");
$DBI::result->execute();

while(@row = $DBI::result->fetchrow_array) {

        $wy = substr($row[0],2,2);
        $wm = substr($row[0],4,2);
        $wd = substr($row[0],6,2);

        $datestr = "$wy$wm$wd";
        $wday = `date -d $datestr +%w`;

	$time = "";
	$color = "#$COLORS[$row[1]]";

	if ($row[6]) {
		$time = "($row[6])";
	}
	print "<li><font color=\"$color\">$DAYS[$wday], $row[2] $time</font></li>\n";
}

$dbh->disconnect();

print "<br><br><center><a href=\"http://nason.com\">Schedule'N Event Management 2.4 &copy;2008 Nason Tackett</a></center>\n";

exit;
