#!/usr/bin/perl

##use strict; 
use CGI; 
use CGI::Carp qw ( fatalsToBrowser ); 
use File::Basename; 

my $query = new CGI;
my $filename = $query->param("fileupload");
my $username = $query->param("username");
my $date = $query->param("date");

use DBI();
require "../db.cfg";       ## Database Connection


$DBI::result = $dbh->prepare("select * from `setup`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $SETUP{$row[0]} = $row[1];
}


$DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` = \"$date\"");
$DBI::result->execute();
my $files = "";
while(my @row = $DBI::result->fetchrow_array) {
	$files = $row[16];
}

$CGI::POST_MAX = 1024 * 5000; 
my $safe_filename_characters = "a-zA-Z0-9_.-"; 
my $upload_dir = $SETUP{'Upload Directory'}; 

if ( !$filename ) 
{ 
 print $query->header ( ); 
 print "There was a problem uploading your file. Try a smaller file. The Max Size is 5MB..";
 exit; 
} 

my ( $name, $path, $extension ) = fileparse ( $filename, '\..*' ); 
$filename = $name . $extension; 
$filename =~ tr/ /_/; 
$filename =~ s/[^$safe_filename_characters]//g; 

if ( $filename =~ /^([$safe_filename_characters]+)$/ ) 
{ 
 $filename = $1; 
} 
else 
{ 
 die "Filename contains invalid characters"; 
} 

my $upload_filehandle = $query->upload("fileupload"); 

open ( UPLOADFILE, ">$upload_dir/$filename" ) or die "$!"; 
binmode UPLOADFILE; 

while ( <$upload_filehandle> ) 
{ 
 print UPLOADFILE; 
} 

close UPLOADFILE; 

$files =~ s/\"/\\"/g;
my $filesname = $query->param("filesname");
if ($filesname eq "") {
	if (length($filename) > 25) {
        	$filesname = substr($filename,-25,25);
	} else {
		$filesname = $filename;
	}
}

my $newfiles = "$files <li><a href=\\\"$SETUP{'Upload File URL'}$filename\\\">$filesname</a><br>";
my $MYSQL = "UPDATE `gigs` SET `files`=\"$newfiles\" WHERE `date`=\"$date\"";
$dbh->do("$MYSQL"); 

print $query->header ( ); 
print <<END_HTML; 
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "DTD/xhtml1-strict.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"> 
 <head> 
   <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
   <title>Uploaded!</title> 
   <style type="text/css"> 
     img {border: none;} 
   </style> 
 </head> 
 <body> 
   <p>Upload Successful!</p> 
 <form action="edit.cgi" method="post">
 <input type="hidden" name="uploadsucess" value="1">
 <input type="hidden" name="username" value="$username">
 <input type="submit" name="$date" value="Ok">
 </form>
 </body> 
</html> 
END_HTML
