#!/usr/bin/perl

###################################################
####      developed by: Nason Tackett          ####
####             nason@nason.com               ####
###################################################

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
    $value =~ s/"/\"/g;
    $value =~ s/'/\'/g;
    $FORM{$name} = $value;
}

## Make and array out of the query string
@strings = split(/&/, $ENV{'QUERY_STRING'});
foreach $string (@strings) {
        $string =~ s/%20/ /i;
        $string =~ s/\+/ /ig;
        $string =~ s/\%7C/\|/ig;
        $string =~ s/\%24/\$/ig;
        $string =~ s/\%0A//ig;
        $string =~ s/\%2F/\//ig;
        $string =~ s/\%26/\&/ig;
        $string =~ s/\%27/'/ig;
        $string =~ s/\%28/(/ig;
        $string =~ s/\%29/)/ig;
        ($name,$value) = split(/=/,$string);
        $FORM{$name} = $value;
}

use DBI();
require "db.cfg";       ## Database Connection

print "Content-type:text/html\n\n";

$DBI::result = $dbh->prepare("select * from `setup`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $SETUP{$row[0]} = $row[1];
}

        print "<center><img src=\"$SETUP{'Company Logo'}\"></center>\n";
        print "<center><font size=5>$SETUP{'Company Name'} Inventory</font></center><br>\n";
        print "<center><font size=3>$SETUP{'Shipping Address'}<br>$SETUP{'Shipping City'}, $SETUP{'Shipping State'}$SETUP{'Shipping Zip'}<br>$SETUP{'Phone Number'}</font></center><br>\n";
        print "<FORM METHOD=\"POST\" name=\"toolbar\" ACTION=\"viewinventory.cgi\">\n";
        print "<input type=\"hidden\" name=\"username\" value=\"$username\">\n";
        print "<center><table bgcolor=\"#99ccff\" bordercolor=\"#FFFFFF\" border=1><tr><td><input type=\"submit\" name=\"show\" value=\"Show All Inventory\"></td><td><input type=\"submit\" name=\"bydate\" value=\"Show Available Inventory by Date\"> <input type=\"text\" name=\"month\" length=\"2\" size=\"2\">/<input type=\"text\" name=\"day\" length=\"2\" size=\"2\">/<input type=\"text\" name=\"year\" length=\"4\" size=\"4\"> (MM/DD/YYYY)</td></tr></table></center>\n";
        print "</form>\n";
        print "<center><img src=\"http://devineonline.com/devine/images/mysql.jpg\"></center><br>\n";


if ($FORM{'bydate'}) {
	&showbydate;
	$dbh->disconnect();
	print "<br><br><center><a href=\"http://nason.com\">Schedule'N Event Management 2.4 &copy;2008 Nason Tackett</a></center>\n";
	exit;
}

print <<EOT;
                        <FORM METHOD="POST" ACTION="viewinventory.cgi">
			<center><table border=1><tr><td>Item</td><td>QTY on hand</td></tr>			
EOT

	&getinventory;
        foreach $key (@ALL) {
		if ($ALLITEMS{$key}) {
			$serialname = "SERIAL$key";
			print "<tr><td>$ALLITEMS{$key}</td><td>$QTYONHAND{$key}</td></tr>\n";
		}
	}

sub getinventory {

	if ($date =~ /\./) {
		($shortdate,$junk) = split(/\./,$date);
	} else {
		$shortdate = $date;
	}

        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` LIKE '%$shortdate%'");
        $DBI::result->execute();
        while(@myrow = $DBI::result->fetchrow_array) {
		$myrow[0] =~ s/\.00//;
		$EVENTNAME{$myrow[0]} = $myrow[2];
	}
	
	$DBI::result = $dbh->prepare("select * from `gear2` WHERE `date` LIKE '%$shortdate%' AND `date` <> \"$date\"");
	$DBI::result->execute();
	%EQUIP = "";
	while(@myrow = $DBI::result->fetchrow_array) {
		$EQUIP{$myrow[1]}=$EQUIP{$myrow[1]} + $myrow[2];
                $USEACC{$myrow[1]} = $myrow[3];  
                $USEACC2{$myrow[1]} = $myrow[4];		
	}

        $DBI::result = $dbh->prepare("select * from `inventory` WHERE `QTY` > 0  ORDER BY `NAME` DESC");
        $DBI::result->execute();

	@ALL = "";
	%QTY = "";
	%ISSER = "";
	$total = 0;    
        while(@myrow = $DBI::result->fetchrow_array) {
##		if ($myrow[2] > 0) {
			unless (!$myrow[0]) {
				push(@ALL,$myrow[0]);
			}
			$ALLITEMS{$myrow[0]} = $myrow[1];
                	if ($row[5] eq "1") {
                        	$KEYITEMS{$myrow[0]} = $myrow[1];
                	} else {
                        	$ITEMS{$myrow[0]} = $myrow[1];  
                	}
                	$QTY{$myrow[0]} = $myrow[2] - $EQUIP{$myrow[0]};
			$QTYONHAND{$myrow[0]} = $myrow[2];
                	$ACC{$myrow[0]} = $myrow[3];
                	$ACC2{$myrow[0]} = $myrow[4];
			if ($myrow[5] eq "1") {
				$ISSER{$myrow[0]} = "checked";
			}
##		}
		if ($myrow[0] > $total) {
			$total = $myrow[0];
		}
        }
}
1;



sub showbydate {

	$date = "$FORM{'year'}$FORM{'month'}$FORM{'day'}";

	&getinventory;

	$DBI::result = $dbh->prepare("select * from `gear2` WHERE `date` = \"$date\"");
	$DBI::result->execute();

	while(@row = $DBI::result->fetchrow_array) {
		$GEARUSED{$row[1]} = $row[2];
		$USEACC{$row[1]} = $row[3];
		$USEACC2{$row[1]} = $row[4];
		$RENTCO{$row[1]} = $row[6];
		$RENTQTY{$row[1]} = $row[5]; 
		$GEARQTY{$row[1]} = $row[2];
	}

print <<EOT;
                        <center><table bgcolor="#99ccff" bordercolor="#FFFFFF" border=1>
                        <tr><td><b>Inventory Available for $FORM{'month'}/$FORM{'day'}/$FORM{'year'}</b></td></tr>
                        <tr><td>
                        <table border=1><tr><td>Item</td><td>QTY Avl</td></tr>
EOT

	foreach $key (@ALL) {
		if ($ALLITEMS{$key} && ($hide ne "1" || ($hide eq "1" && ($GEARUSED{$key} + $RENTQTY{$key}) > 0))) {
			$explainyourself = "";
			if ($QTY{$key} - $GEARUSED{$key} lt 0) {
				$color = "bgcolor=red";
				$rentalqty = $GEARUSED{$key} - $QTY{$key};
			} elsif ($QTY{$key} - $GEARUSED{$key} eq 0) {
				$color = "bgcolor=yellow";
			} else {
				$color = "";
			}
                        if ($RENTCO{$key}) {
                                $color = "bgcolor=yellow";
                                $rentalqty = $RENTQTY{$key};
                                $explainyourself = "<td>Rental From:<input type=\"text\" name=\"RENT$key\" value=\"$RENTCO{$key}\" size=\"30\"><br>QTY: $rentalqty</td>";
                        }
			$myqty = $QTY{$key} - ($GEARUSED{$key} + $RENTQTY{$key}); 
			print "<tr $color><td>$ALLITEMS{$key}</td><td>$myqty</td></tr>\n";
		}
	}
}
1;

print "<br><br><center><a href=\"http://nason.com\">Schedule'N Event Management 2.0 &copy;2008 Nason Tackett</a></center>\n";

$dbh->disconnect();
exit;
