#!/usr/bin/perl

###################################################
#### 	  developed by: Nason Tackett          ####
####             nason@nason.com               ####
###################################################

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
    $value =~ s/"/\"/g;
    $value =~ s/'/\'/g;   
    $FORM{$name} = $value;
}

## Make and array out of the query string
@strings = split(/&/, $ENV{'QUERY_STRING'});
foreach $string (@strings) {
        $string =~ s/%20/ /i;
        $string =~ s/\+/ /ig;
        $string =~ s/\%7C/\|/ig;
        $string =~ s/\%24/\$/ig;
        $string =~ s/\%0A//ig;
        $string =~ s/\%2F/\//ig;
        $string =~ s/\%26/\&/ig;
        $string =~ s/\%27/'/ig;
        $string =~ s/\%28/(/ig;
        $string =~ s/\%29/)/ig;
        ($name,$value) = split(/=/,$string);
        $FORM{$name} = $value;
}

use DBI();
require "db.cfg";       ## Database Connection

@DAYS = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
@month = ("", "Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec");

$DBI::result = $dbh->prepare("select * from `setup`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
	$SETUP{$row[0]} = $row[1];
}

$DBI::result = $dbh->prepare("select * from `gig types`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
	$EVENT[$row[0]]=$row[1];
	$COLORS[$row[0]]=$row[2];        
}   


require "./edit/invoice.inc";
require "./edit/client.inc";

print "Content-type:text/html\n\n";
##ORDER:    0123456789ABCD
##SEQUENCE: 29A17B480C63D5
if ($FORM{'invoicehash'}) {
	$s0=substr($FORM{'invoicehash'},8,1);
        $s1=substr($FORM{'invoicehash'},3,1);
        $s2=substr($FORM{'invoicehash'},0,1);
        $s3=substr($FORM{'invoicehash'},11,1);
        $s4=substr($FORM{'invoicehash'},6,1);
        $s5=substr($FORM{'invoicehash'},13,1);
        $s6=substr($FORM{'invoicehash'},10,1);
        $s7=substr($FORM{'invoicehash'},4,1);
        $s8=substr($FORM{'invoicehash'},7,1);
        $s9=substr($FORM{'invoicehash'},1,1);
	$edit = $s0.$s1.$s2.$s3.$s4.$s5.$s6.$s7.".".$s8.$s9;

	chdir("./edit/");
        open(TEMPLATE,"invoice.htm");
        @TEMPLATE = <TEMPLATE>;
        close TEMPLATE;

	&makeinvoice;
	print $invoice;
	$dbh->disconnect();
	exit;
}

$dbh->disconnect();
exit;

