# --------------------------------------------------------

#
# Table structure for table `color preset 1`
#

CREATE TABLE `color preset 1` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `color` varchar(30) default NULL,
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0;

#
# Dumping data for table `color preset 1`
#

INSERT INTO `color preset 1` VALUES (1, 'background', 'FFFF66');
INSERT INTO `color preset 1` VALUES (2, 'default font', '000000');
INSERT INTO `color preset 1` VALUES (3, 'table background', '339933');
INSERT INTO `color preset 1` VALUES (4, 'table bordercolor', 'FF3300');
INSERT INTO `color preset 1` VALUES (5, 'calendar background', 'FFFFFF');
INSERT INTO `color preset 1` VALUES (6, 'calendar today', 'CCFF99');
INSERT INTO `color preset 1` VALUES (7, 'labor full highlight', 'FFFF00');
INSERT INTO `color preset 1` VALUES (8, 'signup ok highlight', '66CC66');
INSERT INTO `color preset 1` VALUES (9, 'delinquent font', 'FF0000');
INSERT INTO `color preset 1` VALUES (10, 'error font', 'FF00CC');

# --------------------------------------------------------

#
# Table structure for table `color preset 2`
#

CREATE TABLE `color preset 2` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `color` varchar(30) default NULL,
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0;

#
# Dumping data for table `color preset 2`
#

INSERT INTO `color preset 2` VALUES (1, 'background', '000000');
INSERT INTO `color preset 2` VALUES (2, 'default font', 'CCCCCC');
INSERT INTO `color preset 2` VALUES (3, 'table background', '333333');
INSERT INTO `color preset 2` VALUES (4, 'table bordercolor', '993300');
INSERT INTO `color preset 2` VALUES (5, 'calendar background', 'FFFFFF');
INSERT INTO `color preset 2` VALUES (6, 'calendar today', 'FF3300');
INSERT INTO `color preset 2` VALUES (7, 'labor full highlight', 'CCFFCC');
INSERT INTO `color preset 2` VALUES (8, 'signup ok highlight', '66CC66');
INSERT INTO `color preset 2` VALUES (9, 'delinquent font', 'FFFFFF');
INSERT INTO `color preset 2` VALUES (10, 'error font', '990000');

# --------------------------------------------------------

#
# Table structure for table `color preset 3`
#

CREATE TABLE `color preset 3` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `color` varchar(30) default NULL,
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0;

#
# Dumping data for table `color preset 3`
#

INSERT INTO `color preset 3` VALUES (1, 'background', 'FFFFFF');
INSERT INTO `color preset 3` VALUES (2, 'default font', '000000');
INSERT INTO `color preset 3` VALUES (3, 'table background', '99ccff');
INSERT INTO `color preset 3` VALUES (4, 'table bordercolor', 'FFFFFF');
INSERT INTO `color preset 3` VALUES (5, 'calendar background', 'FFFFFF');
INSERT INTO `color preset 3` VALUES (6, 'calendar today', 'FFFFCC');
INSERT INTO `color preset 3` VALUES (7, 'labor full highlight', '99CCFF');
INSERT INTO `color preset 3` VALUES (8, 'signup ok highlight', '00FF00');
INSERT INTO `color preset 3` VALUES (9, 'delinquent font', 'FF0000');
INSERT INTO `color preset 3` VALUES (10, 'error font', 'FF0000');

# --------------------------------------------------------

#
# Table structure for table `color setup`
#

CREATE TABLE `color setup` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `color` varchar(30) default NULL,
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0;

#
# Dumping data for table `color setup`
#

INSERT INTO `color setup` VALUES (1, 'background', '000000');
INSERT INTO `color setup` VALUES (2, 'default font', 'CCCCCC');
INSERT INTO `color setup` VALUES (3, 'table background', '333333');
INSERT INTO `color setup` VALUES (4, 'table bordercolor', '993300');
INSERT INTO `color setup` VALUES (5, 'calendar background', 'FFFFFF');
INSERT INTO `color setup` VALUES (6, 'calendar today', 'FF3300');
INSERT INTO `color setup` VALUES (7, 'labor full highlight', 'CCFFCC');
INSERT INTO `color setup` VALUES (8, 'signup ok highlight', '66CC66');
INSERT INTO `color setup` VALUES (9, 'delinquent font', 'FFFFFF');
INSERT INTO `color setup` VALUES (10, 'error font', '990000');
